package client

import "forge.redroom.link/yves/meowlib"

type InternalUserMessage struct {
	message *meowlib.UserMessage
	dbid    int64
}

func ProcessOutboundTextMessage(peer *Peer, text string, srv *Server) ([]byte, error) {
	// Creating User message
	usermessage, err := peer.BuildSimpleUserMessage([]byte(text))
	if err != nil {
		return nil, err
	}
	// Prepare cyphered + packed user message
	packedMsg, err := peer.ProcessOutboundUserMessage(usermessage)
	if err != nil {
		return nil, err
	}
	// Creating Server message for transporting the user message
	toServerMessage := srv.BuildToServerMessageFromUserMessage(packedMsg)
	return srv.ProcessOutboundMessage(toServerMessage)
}
