package client

import (
	"strconv"
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestGetFromPublicKey(t *testing.T) {
	id := CreateIdentity("test")
	id.Save()
	for i := 1; i < 10; i++ {
		var p Peer
		p.Name = "test" + strconv.Itoa(i)
		p.Contact.ContactPublicKey = "stringToFind" + strconv.Itoa(i)
		id.Peers = append(id.Peers, p)
	}
	p5 := id.Peers.GetFromPublicKey("stringToFind5")
	assert.Equal(t, p5.Name, "test5")
}
